function [R1,R2,CHo,CHoCell] = fun1ev( x,ch )


%%%% RATE 1 %%%%
% Compute H(X|Z1)
pz1_0 = x * (1-ch(4));
pz1_1 = (1-x) * (1-ch(4));
pz1_e = ch(4);
pz1_0_x0 = 1-ch(4);
pz1_1_x0 = 0;
pz1_e_x0 = ch(4);
px0_z1_0 = x(1)*pz1_0_x0/pz1_0;
px0_z1_1 = x(1)*pz1_1_x0/pz1_1;
px0_z1_e = x(1)*pz1_e_x0/pz1_e;

HX_Z1 = pz1_0*bh(px0_z1_0) + pz1_1*bh(px0_z1_1) + pz1_e*bh(px0_z1_e);

% Compute H(X|Z2)
pz2_0 = x * (1-ch(3));
pz2_1 = (1-x) * (1-ch(3));
pz2_e = ch(3);
pz2_0_x0 = 1-ch(3);
pz2_1_x0 = 0;
pz2_e_x0 = ch(3);
px0_z2_0 = x(1)*pz2_0_x0/pz2_0;
px0_z2_1 = x(1)*pz2_1_x0/pz2_1;
px0_z2_e = x(1)*pz2_e_x0/pz2_e;

HX_Z2 = pz2_0*bh(px0_z2_0) + pz2_1*bh(px0_z2_1) + pz2_e*bh(px0_z2_e);

% R1:
R1 = HX_Z1 - HX_Z2;

%%%% RATE 2 %%%%
% Compute H(X|Y1)
py1_0 = x * (1-ch(2));
py1_1 = (1-x) * (1-ch(2));
py1_e = ch(2);
py1_0_x0 = 1-ch(2);
py1_1_x0 = 0;
py1_e_x0 = ch(2);
px0_y1_0 = x(1)*py1_0_x0/py1_0;
px0_y1_1 = x(1)*py1_1_x0/py1_1;
px0_y1_e = x(1)*py1_e_x0/py1_e;

HX_Y1 = py1_0*bh(px0_y1_0) + py1_1*bh(px0_y1_1) + py1_e*bh(px0_y1_e);

% R2:
R2 = HX_Z2 - HX_Y1;


CHout = cell(1,4);
CHCellout = cell(1,4);

%%%% CHANNEL 1 - (X-Y2) %%%%
o.ChannelName = 'X_Y2';
o.parBEC = ch(1);
CHout{1} = o;
CHCellout{1} = ch(1);


%%%% CHANNEL 2 - (X-Y1) %%%%
o.ChannelName = 'X_Y1';
o.parBEC = ch(2);
CHout{2} = o;
CHCellout{2} = ch(2);


%%%% CHANNEL 3 - (X-Z2) %%%%
o.ChannelName = 'X_Z2';
o.parBEC = ch(3);
CHout{3} = o;
CHCellout{3} = ch(3);



%%%% CHANNEL 4 - (X-Z1) %%%%
o.ChannelName = 'X_Z1';
o.parBEC = ch(4);
CHout{4} = o;
CHCellout{4} = ch(4);


CHo = CHout;
CHoCell = CHCellout;

