function [R1,R2,ChOut,CHoCell] = init_channels(ch,chmod)


% Compute optimum input distribution (conditional entropy)
switch chmod
    case 1
        options = optimset('TolFun', 1e-20,'Display', 'off');
        x0 = [0.2,0.1,0.8];
        A = [0 1 -1; 0 0 0; 0 0 0];
        b = [0 0 0]'; 
        % x -> x(1): pvst (P_V(v))
        %      x(2): px_v_st0 (P_{X|V}(1|0))
        %      x(3): px_v_st1 (P_{X|V}(0|1))
        % We have proved that x(1)=0.5, x(2)=x(3) (symmetry)
        [x,~]= fmincon(@(x)fun1(x,ch),x0,[],[],A,b,...
            [0 0 0],[1 1 1],[],options);
    
end
% 'Channels':
%  -1-       -2-       -3-      -4-
% U-Y2  ||? U-Y1  ||  U-Z2  ||  U-Z1 
%   -5-       -6-        -7-       -8-
% X-Y2|U ||  X-Z2|U  ||?X-Z1|U ||  X-U
[R1,R2,ChOut,CHoCell] = fun1ev(x,ch);







